**Added native Nvme SSD boot support to GA-Z77-DS3H BIOS for use with an Nvme SSD drive attached to a M.2 Nvme to PCI-e adapter**

Must use a PCI-e card adapter to M.2 NVMe key connected to a spare PCI Express Slot that's x4 or greater.

Please note that these BIOSes are Untested but I used the same modding process to great success on a vanilla GA-Z97-D3H(F7) BIOS downloaded from the official Gigabyte support website so my Z77-DS3H(F7) mods should work.  

BIOS should be used at your own risk. I accept NO RESPONSIBILITY for any damage to your motherboard or any other devices connected to it. 
BIOS flashing is considered 'risky' ** You've been warned ! ** 


**Before flashing the modded BIOS to your motherboard, do the following;**

- Get a Fat32 formatted flash drive  
- Make a backup of your working BIOS and save to the flash drive
- Make a backup of your BIOS Profile (this will save all of your BIOS settings before they get wiped/reset to defaults during a BIOS flash) and save to the flash drive.
- IMPORTANT - Check the Revision number of your motherboard, it will be printed somewhere on the PCB and should say Revision or Rev. 1.0 or Rev. 1.1 
- Save the correct BIOS Revision of the modified BIOS to your flash drive.  


**So what's been modified in this BIOS ?**

I navigated into the Volume Image of the BIOS that contains all the relevant DXE drivers (including the all important CSMCORE) and I inserted a EFI Module file named NvmExpressDxe_5.ffs in there. The BIOS has been saved as a .rom file which should be recognised in the UEFI BIOS Flash Utility.


**Flashing the BIOS**

- Copy the correct modded Z77DS3H_11a file for your mobo onto your FAT32 formatted USB flash drive.
- Enter the Z77-DS3H UEFI BIOS and press F8 to use the Q-Flash Bios flash utility.
- Navigate to your saved modded BIOS file and enter the Flash process. 
- A Pop-Up window should show you info about the modded BIOS ready to be flashed. Note, the info will appear identicle to the vanilla BIOS.   
- Enter Yes to start the BIOS flashing and then leave it alone.
- After BIOS has been flashed, the machine will switch itself off briefly and eventually restart. 
- When that's done, enter the BIOS and navigate to the 'Save & Exit' window.
- Select 'Load Profiles' and navigate to your flash drive for the BIOS Profile you saved earlier.
- After loading your saved Profile, Save and Exit the BIOS.  

Please note that the UEFI BIOS Screen in use will not look any different with this modded BIOS. It does not show any additional BIOS features however your Nvme drive manufacturer model will show up in your UEFI Boot selection after you have formatted the Nvme SSD drive in your OS and will of course be bootable.    

- Robbish 
-----------------------------------------------------------------

BEFORE PURCHASING a M.2 Nvme to PCI-e adapter..
Please note that the Z77-DS3H does not support Bifurcation so do not purchase a 4 port M.2 Nvme to PCI-e adapter. A single slot M.2 Nvme to PCI-e adapter or a Dual Slot PCIe card (typically has a x1 Nvme key connected to the PCI-e bus and a x1 M.2 key typically connected to the Sata bus) will suffice. These cards are available on eBay and Ali Express at faily low prices.

Beware: some motherboards have a switch parameter to restrict the bandwith of a single PCI Express Port to switch between x1 , x4 , x8 and x16. I don't believe that the Z77-DS3H has this feature but my GA-Z97-D3H does have that setting and it caught me out. 

-----------------------------------------------------------------

**Resources that I used to modify the BIOS**

Vanilla BIOS files from Gigabyte support website;

GA-Z77-DS3H BIOS Rev 1.0
https://www.gigabyte.com/uk/Motherboard/GA-Z77-DS3H-rev-10#ov

GA-Z77-DS3H BIOS Rev 1.1
https://www.gigabyte.com/uk/Motherboard/GA-Z77-DS3H-rev-11#ov

EFI Module file NvmExpressDxe_5.ffs	
(available from the guide on the Win-Raid Forum 'HowTo get full Nvme support for all systems with an AMI UEFI Bios') 
https://winraid.level1techs.com/t/howto-get-full-nvme-support-for-all-systems-with-an-ami-uefi-bios/30901

BIOS Tool
UEFITool_v0.28.0_mac.app (app also available in Linux and Windows flavours)
https://github.com/LongSoft/UEFITool/releases/tag/0.28.0


Credits:
Fernanado on Level1Techs Win-Raid forum, Clover Team, CodeRush and vit9696

